/*
 *
 * Copyright (C) 2003 Sadysta ( http://sadysta.ath.cx )
 * Copyright (C) 2007 Tomasz Ostrowski ( http://ostry.w.szu.pl ) - modified from 1.8.9 source
 *
 * This file is part of Free GG.
 *
 * Free GG is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Free GG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Free GG; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Contact.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

#include "Main.h"
#include "GaduThread.h"

TContactForm *ContactForm;
extern TGaduThread *gg_thread;
extern AnsiString GGDir;
//---------------------------------------------------------------------------
__fastcall TContactForm::TContactForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void TContactForm::WriteContacts(AnsiString filename)
{
        TStringList *S;
        S = new TStringList();
        for (int i = 0; i < MainForm -> List -> Items -> Count; i++)
                S -> Add (MainForm -> List -> Items -> Item[i] -> SubItems -> Strings[2] + ";" +
                          MainForm -> List -> Items -> Item[i] -> SubItems -> Strings[3] + ";" +
                          MainForm -> List -> Items -> Item[i] -> SubItems -> Strings[4] + ";" +
                          MainForm -> List -> Items -> Item[i] -> Caption + ";" +
                          MainForm -> List -> Items -> Item[i] -> SubItems -> Strings[5] + ";" +
                          MainForm -> List -> Items -> Item[i] -> SubItems -> Strings[6] + ";" +
                          MainForm -> List -> Items -> Item[i] -> SubItems -> Strings[0] + ";;0;;0;");

        if (filename != "") S -> SaveToFile (filename); else
                            S -> SaveToFile (contacts_filename);

        if (filename == "")
        {
                S -> Clear();
                for (int i = 0; i < MainForm -> List -> Items -> Count; i++)
                        if (MainForm -> List -> Items -> Item[i] -> SubItems -> Strings[7] == "3")
                                S -> Add (MainForm -> List -> Items -> Item[i] -> SubItems -> Strings[0]);

                S -> SaveToFile (friends_filename);

                S -> Clear();
                for (int i = 0; i < MainForm -> List -> Items -> Count; i++)
                        if (MainForm -> List -> Items -> Item[i] -> SubItems -> Strings[7] == "4")
                                S -> Add (MainForm -> List -> Items -> Item[i] -> SubItems -> Strings[0]);

                S -> SaveToFile (foes_filename);
        }
                            
        delete S;
}
//---------------------------------------------------------------------------
void __fastcall TContactForm::ResetContactList()
{
        for (int i = 0; i < MainForm -> List -> Items -> Count; i++)
        {
                MainForm -> List -> Items -> Item[i] -> ImageIndex = 0;
                MainForm -> List -> Items -> Item[i] -> SubItems -> Strings[1] = "";
        }

        MainForm -> List -> CustomSort (NULL, 0);
}
//---------------------------------------------------------------------------
void TContactForm::ReadContacts()
{
        TStringList *S;
        S = new TStringList();
        if (FileExists (contacts_filename)) S -> LoadFromFile (contacts_filename);

        TListItem *I;

        for (int i = 0; i < S -> Count; i++)
        {
			AnsiString array[15]; // Teoretycznie jest uywanych 11, reszta na zapas
			int j = 0;

			// buf = strtok (S -> Strings[i].c_str(), ";");
			for (int k = 0; k < S -> Strings[i].Length(); k++)
					if (S -> Strings[i][k+1] != ';') array[j] += S -> Strings[i][k+1]; else j++;

			// sprawd czy kontaktu nie ma ju na licie
			bool bExists = false;
			for(int i=0; i< MainForm -> List -> Items->Count; i++)
			{
				AnsiString test0 = MainForm -> List ->Items->Item[i]->SubItems->Strings[0];
				AnsiString test1 = MainForm -> List ->Items->Item[i]->SubItems->Strings[1];
				AnsiString test2 = MainForm -> List ->Items->Item[i]->SubItems->Strings[2];
				AnsiString test3 = MainForm -> List ->Items->Item[i]->SubItems->Strings[3];
				AnsiString test4 = MainForm -> List ->Items->Item[i]->SubItems->Strings[4];
				AnsiString test5 = MainForm -> List ->Items->Item[i]->SubItems->Strings[5];

				if( (array[6] != "" && MainForm -> List -> Items->Item[i]->SubItems->Strings[0] == array[6]) ||
					(array[4] != "" && MainForm -> List -> Items->Item[i]->SubItems->Strings[5] == array[4])
				)
				{
					I = MainForm -> List -> Items -> Item[i];
					bExists = true;
					break;
				}
			}
			if(!bExists)
			{
				I = MainForm -> List -> Items -> Add();
				I -> Caption = array[3];
				I -> SubItems -> Add (array[6]);
				I -> SubItems -> Add ("");

				// Add rest of data
				I -> SubItems -> Add (array[0]); // Name
				I -> SubItems -> Add (array[1]); // Family-name
				I -> SubItems -> Add (array[2]); // Nickname
				I -> SubItems -> Add (array[4]); // Phone number
				I -> SubItems -> Add (array[5]); // Grupa
				I -> SubItems -> Add ("1"); // Rodzaj
				I -> SubItems -> Add (""); // IP
				I -> SubItems -> Add (""); // Port
			}
			else //mofify existing item
			{
				I -> Caption = array[3];
				I -> SubItems->Strings[0] = array[6];
				//I -> SubItems -> Add ("");

				// Modify rest of data
				I -> SubItems -> Strings[2] = (array[0]); // Name
				I -> SubItems -> Strings[3] = (array[1]); // Family-name
				I -> SubItems -> Strings[4] = (array[2]); // Nickname
				I -> SubItems -> Strings[5] = (array[4]); // Phone number
				I -> SubItems -> Strings[6] = (array[5]); // Grupa
				//I -> SubItems -> Add ("1"); // Rodzaj
				//I -> SubItems -> Add (""); // IP
				//I -> SubItems -> Add (""); // Port
			}
		}

		S -> Clear();
		if (FileExists (friends_filename)) S -> LoadFromFile (friends_filename);
        for (int i = 0; i < S -> Count; i++)
                for (int j = 0; j < MainForm -> List -> Items -> Count; j++)
                        if (S -> Strings [i] == MainForm -> List -> Items -> Item[j] -> SubItems -> Strings[0])
								MainForm -> List -> Items -> Item[j] -> SubItems -> Strings[7] = "3";

        S -> Clear();
        if (FileExists (foes_filename)) S -> LoadFromFile (foes_filename);
        for (int i = 0; i < S -> Count; i++)
                for (int j = 0; j < MainForm -> List -> Items -> Count; j++)
                        if (S -> Strings [i] == MainForm -> List -> Items -> Item[j] -> SubItems -> Strings[0])
                                MainForm -> List -> Items -> Item[j] -> SubItems -> Strings[7] = "4";

        delete S;

		MainForm -> List -> CustomSort (NULL, 0);
		/** \todo "brudne" rozwizanie problemu artefaktw przy ownerdraw */
		ShowScrollBar(MainForm ->List->Handle, SB_VERT , true);
		MainForm->List->Columns->Items[0]->AutoSize = true;
}
//---------------------------------------------------------------------------
void TContactForm::ReadContactsFromList(TStringList *S)
{
	TListItem *I;
	for (int i = 0; i < S -> Count; i++)
	{
			AnsiString array[15]; // Teoretycznie jest uywanych 11, reszta na zapas
			int j = 0;

			// buf = strtok (S -> Strings[i].c_str(), ";");
			for (int k = 0; k < S -> Strings[i].Length(); k++)
					if (S -> Strings[i][k+1] != ';') array[j] += S -> Strings[i][k+1]; else j++;

			// sprawd czy kontaktu nie ma ju na licie
			bool bExists = false;
			for(int i=0; i< MainForm -> List -> Items->Count; i++)
			{
				AnsiString test0 = MainForm -> List ->Items->Item[i]->SubItems->Strings[0];
				AnsiString test1 = MainForm -> List ->Items->Item[i]->SubItems->Strings[1];
				AnsiString test2 = MainForm -> List ->Items->Item[i]->SubItems->Strings[2];
				AnsiString test3 = MainForm -> List ->Items->Item[i]->SubItems->Strings[3];
				AnsiString test4 = MainForm -> List ->Items->Item[i]->SubItems->Strings[4];
				AnsiString test5 = MainForm -> List ->Items->Item[i]->SubItems->Strings[5];

				if( (array[6] != "" && MainForm -> List -> Items->Item[i]->SubItems->Strings[0] == array[6]) ||
					(array[4] != "" && MainForm -> List -> Items->Item[i]->SubItems->Strings[5] == array[4])
				)
				{
					I = MainForm -> List -> Items -> Item[i];
					bExists = true;
					break;
				}
			}
			if(!bExists)
			{
				I = MainForm -> List -> Items -> Add();
				I -> Caption = array[3];
				I -> SubItems -> Add (array[6]);
				// powoduje zerwanie poczenia z serwerem
				//int iGGUIN = StrToIntDef(array[6], -1);
				//if(iGGUIN != -1)
				//	gg_thread -> AddNotify (iGGUIN, 3);	// default: friend
				I -> SubItems -> Add ("");

				// Add rest of data
				I -> SubItems -> Add (array[0]); // Name
				I -> SubItems -> Add (array[1]); // Family-name
				I -> SubItems -> Add (array[2]); // Nickname
				I -> SubItems -> Add (array[4]); // Phone number
				I -> SubItems -> Add (array[5]); // Grupa
				I -> SubItems -> Add ("1"); // Rodzaj
				I -> SubItems -> Add (""); // IP
				I -> SubItems -> Add (""); // Port
			}
			else //mofify existing item
			{
				I -> Caption = array[3];
				if( I -> SubItems->Strings[0] != array[6] )
				{
					I -> SubItems->Strings[0] = array[6];
					// powoduje zerwanie poczenia z serwerem
					//int iGGUIN = StrToIntDef(array[6], -1);
					//if(iGGUIN != -1)
					//	gg_thread -> AddNotify (iGGUIN, 3);	// default: friend
				}
				//I -> SubItems -> Add ("");

				// Modify rest of data
				I -> SubItems -> Strings[2] = (array[0]); // Name
				I -> SubItems -> Strings[3] = (array[1]); // Family-name
				I -> SubItems -> Strings[4] = (array[2]); // Nickname
				I -> SubItems -> Strings[5] = (array[4]); // Phone number
				I -> SubItems -> Strings[6] = (array[5]); // Grupa
				//I -> SubItems -> Add ("1"); // Rodzaj
				//I -> SubItems -> Add (""); // IP
				//I -> SubItems -> Add (""); // Port
            }
	}
	MainForm -> List -> CustomSort (NULL, 0);
	/** \todo "brudne" rozwizanie problemu artefaktw przy ownerdraw */
	ShowScrollBar(MainForm ->List->Handle, SB_VERT , true);
	MainForm->List->Columns->Items[0]->AutoSize = true;
}

//---------------------------------------------------------------------------
void __fastcall TContactForm::FormCreate(TObject *Sender)
{
		liEdited = NULL;
		contacts_filename = GGDir + "\\";
		foes_filename = contacts_filename + "foes.dat";
		friends_filename = contacts_filename + "friends.dat";
		contacts_filename += "contacts.dat";
		ReadContacts();
}
//---------------------------------------------------------------------------
void __fastcall TContactForm::Button3Click(TObject *Sender)
{
		if (gguin->Text.Trim() != "" && atoi (gguin -> Text.c_str()) == 0) { MessageBox (Handle, "Wprowadzono nieprawidowy numer GG!", "Free GG", MB_OK | MB_ICONERROR); return; }

		bool exists = false;

        for (int i = 0; i < MainForm -> List -> Items -> Count; i++)
				if (gguin->Text.Trim()!="" && MainForm -> List -> Items -> Item[i] -> SubItems -> Strings [0] == gguin -> Text) exists = true;

        if (exists) MessageBox (Handle, "Wpis z tym numerem GG ju istnieje.", "Blad", MB_OK | MB_ICONERROR); else
        {
                TListItem *I;
                I = MainForm -> List -> Items -> Add();
                I -> Caption = display -> Text; // Wyswietl
				I -> SubItems -> Add (gguin -> Text.Trim()); // GG#
                I -> SubItems -> Add (""); // Status
                I -> SubItems -> Add (firstname -> Text); // Imie
                I -> SubItems -> Add (lastname -> Text); // Nazwisko
                I -> SubItems -> Add (nickname -> Text); // Ksywa
                I -> SubItems -> Add (phone -> Text); // Telefon
                I -> SubItems -> Add (""); // Grupa

                int t;
				switch (status -> ItemIndex)
				{
						case 0:
								t = 1;
						break;

						case 1:
								t = 3;
						break;

						case 2:
								t = 4;
						break;
				}

                I -> SubItems -> Add (t); // Rodzaj
                I -> SubItems -> Add (""); // IP
				I -> SubItems -> Add (""); // Port
				liEdited = I;
				int iGGUIN = StrToIntDef(gguin->Text, -1);
				if(iGGUIN != -1)
					gg_thread -> AddNotify (iGGUIN, t);

                MainForm -> List -> CustomSort (NULL, 0);
        }
}
//---------------------------------------------------------------------------

/** zapisanie kontaktu na licie */
void __fastcall TContactForm::Button2Click(TObject *Sender)
{
        bool exists = false;
        TListItem *I;

        for (int i = 0; i < MainForm -> List -> Items -> Count; i++)
                if (MainForm -> List -> Items -> Item[i] -> SubItems -> Strings [0] == gguin -> Text && gguin->Text!="")
                {
                        I = MainForm -> List -> Items -> Item[i];
                        exists = true;
                }
		if(!exists && liEdited)
		{
			exists = true;
			I = liEdited;
        }

        if (exists)
        {
				I -> Caption = display -> Text; // Wyswietl
				I -> SubItems -> Strings[0] = gguin -> Text.Trim();	 // GG UIN
				I -> SubItems -> Strings[2] = firstname -> Text; // Imie
                I -> SubItems -> Strings[3] = lastname -> Text; // Nazwisko
                I -> SubItems -> Strings[4] = nickname -> Text; // Ksywa
                I -> SubItems -> Strings[5] = phone -> Text; // Tel

                int t;
                switch (status -> ItemIndex)
                {
                        case 0:
                                t = 1;
                        break;

                        case 1:
                                t = 3;
                        break;

                        case 2:
                                t = 4;
                        break;
                }

				if (I -> SubItems -> Strings[7] != t &&
					StrToIntDef(I -> SubItems -> Strings[0], -1) != -1)
                {
                        gg_thread -> RemoveNotify (StrToInt(I -> SubItems -> Strings[0]), StrToInt (I -> SubItems -> Strings[7]));
                        I -> SubItems -> Strings[7] = t;
                        if (t == 4) I -> ImageIndex = 0;
						gg_thread -> AddNotify (StrToInt(I -> SubItems -> Strings[0]), t);
                }

                MainForm -> List -> CustomSort (NULL, 0);
        } else MessageBox (Handle, "Wpis z tym numerem GG nie istnieje.\nZanim zaktualizujesz jego dane musisz go dodac do listy kontaktow.", "Blad", MB_OK | MB_ICONERROR); 
}
//---------------------------------------------------------------------------

void __fastcall TContactForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	liEdited = NULL;
}
//---------------------------------------------------------------------------

